/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "MMLfile.h"

/****************************************************************/
/*					O[oϐiNXǁEEEj		*/
/****************************************************************/
extern	OPSW*			cOptionSW;	//IvVւ̃|C^ϐ

#ifdef _OPENMP
	extern	omp_lock_t		lock_cout;
#endif

/*
Memo:
	read_char();		//t@C or }NA1Byteǂݍ
	@cRead()			//Shift-Jis𔼊pɕϊ@\t
	    GetChar()		//RgER[h̖@\t
		GetString()
	    GetNum()
	    Get****()
	    SetMacro()
	    CallMacro()
		GetCommandID()
*/
//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		const	char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
MMLfile::MMLfile(string&	strFileName):
iFiles(0),
p_macro(0),
f_macro(false),
f_2to1(false),
f_error(false),
offset_Ei(0),
offset_Ev(0),
offset_En(0),
offset_Em(0),
iReleaseVolume(2),
iRepeatMode(0),
iTieMode(0),
timebase(24),
octave_reverse(false),
q_reverse(false),
rest(2),
wait(0),
QMax(8),
priority(0)
{
	try {
		//File open
		nowFile	= new FileInput();
		nowFile->fileopen(strFileName.c_str());

		//ǂݍݎsH
		f_error = nowFile->isError();
		if(f_error == true){
			throw ios_base::failure(strFileName + ": " + strerror(errno));
		} else {
			ptcFiles.push_back(nowFile);
			iFiles = 0;
		}

	} catch (int no) {
		nsc_ErrMsg(no);
		f_error = true;	//G[B
	} catch (const exception& e){
		nsc_ErrMsg(e);
		f_error = true;	//G[B
	}
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MMLfile::~MMLfile(void)
{

	//----------------------
	//Delete Class

	//Jt@CS
	for(vector<FileInput*>::iterator it=ptcFiles.begin(), e=ptcFiles.end(); it!=e; ++it){
		if(cOptionSW->iDebug & DEBUG_Close_Inc){
			_COUT << _T("Close file :");
			cout << (*it)->GetFilename()->c_str() << endl;
		}
		(*it)->close();
		delete *it;
	}
	ptcFiles.clear();

	//}NSB
	for(map<string,string>::iterator it=ptcMac.begin(), e=ptcMac.end(); it!=e; ++it){
		it->second.clear();
	}
	ptcMac.clear();
	lv_Mac.clear();

	//pb`SB
	for(map<size_t,Patch*>::iterator it=ptcPatch.begin(), e=ptcPatch.end(); it!=e; ++it){
		delete	it->second;
	}
	ptcPatch.clear();

}

//==============================================================
//			݃RpC̃t@C[EOF]`FbN
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			bool		true	[EOF]o
//						false	܂I肶ȂB
//==============================================================
bool	MMLfile::eof(void)
{
	return( nowFile->eof() );
}

//==============================================================
//			MMLt@C̏I`FbN
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			bool		true	t@C[EOF]o
//						false	܂I肶ȂB
//==============================================================
bool	MMLfile::eom(void)
{
	if(( iFiles == 0 ) && ( eof() )){
		return(true);
	}
	return(false);
}

//==============================================================
//		CN[ht@C
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//	
//			݂̃t@C|C^ɏĂt@CCN[h
//==============================================================
void	MMLfile::include()
{
	//----------------------
	//Localϐ
	string		_name = "";
	FileInput*	_incFile;

	GetString(&_name, false);

	//----------------------
	//t@CJĂȂ`FbN
	for(vector<FileInput*>::iterator it=ptcFiles.begin(), e=ptcFiles.end(); it!=e; ++it){
		if( *(*it)->GetFilename() == _name ){
			string	errMsg = "The same file \"";
			errMsg += _name + "\" has already been open.";
			Err(errMsg);
		}
	}

	//----------------------
	//File open
	_incFile	= new FileInput();

	_incFile->fileopen(_name.c_str(), &cOptionSW->m_pass_inc);
	if(_incFile->isError() == true){
		f_error = true;
		delete _incFile;		//ǂݍ݂ɎŝŁAŃNXB
		string	errMsg = "\"";
		errMsg += _name + "\" :" + strerror(errno);
		Err(errMsg);
	} else {
		nowFile = _incFile;
		ptcFiles.push_back(_incFile);
		iFiles++; 
	}
}

//==============================================================
//		}N̐ݒ
//--------------------------------------------------------------
//	
//		int		i_Lv	ݒ肷郌x
//	Ԓl
//				
//	
//			݂̃t@C|C^ɏĂ}N`B
//==============================================================
void	MMLfile::SetMacro(int i_Lv)
{
	char	cData;
	string	macro_name		="";
	string	macro_contents	="";

	//Debugp
	if(cOptionSW->iDebug & DEBUG_Macros){
		cout << "Set Macro (Lv=" << i_Lv << ") : ";
	}

	int		iKakko	= 0;

	//------------------
	//}N̎擾
	while((cData = cRead()) > 0x20){
		if(cData == '{'){
			Back();
			break;
		}
		macro_name += cData;
	};

	//------------------
	//}N̏d`FbN
	if(ptcMac.count(macro_name) != 0){
		Err(_T("ɂ̃}N݂͑Ă܂B"));
	}


	//------------------
	//}Ne̎擾
	cData = GetChar();
	if(cData != '{'){
		Err(_T("}N`Jn{܂łB"));
	}

	while(('}' != (cData = GetChar())) || (iKakko != 0)){
		if(eof()){
			Err(_T("I}܂łB"));
		}
		if(cData == '{'){
			iKakko++;
		} else if(cData == '}'){
			iKakko--;
		}
		macro_contents += cData;
	}
	macro_contents += " ";

	//------------------
	//}Ne̐ݒ
	ptcMac[macro_name] = macro_contents;
	lv_Mac[macro_name] = i_Lv;

	//Debugp
	if(cOptionSW->iDebug & DEBUG_Macros){
		cout << "SetMacro ptcMac[" << macro_name << "] = \"" << macro_contents << "\"" << endl;
	}
}

//==============================================================
//		}N̐ݒ
//--------------------------------------------------------------
//	
//		int		i_Lv	폜郌x
//	Ԓl
//				
//	
//			Yx̃}N폜
//==============================================================
void	MMLfile::DeleteMacro(int i_Lv)
{

	//----------------------
	//Localϐ
	string	macro_name;
	int		macro_lv;

	//Debugp
	if(cOptionSW->iDebug & DEBUG_Macros){
		cout << "Delete Macro (Lv=" << i_Lv << ") : " << endl;
	}
		
	//----------------------
	//YLṽ}NB
	map<string,string>::iterator itMac = ptcMac.begin();
	while(itMac != ptcMac.end()){
		macro_name	= itMac->first;
		macro_lv	= lv_Mac[macro_name];
		itMac++;
		if(i_Lv == macro_lv){
			ptcMac.erase(macro_name);
			lv_Mac.erase(macro_name);
			//Debugp
			if(cOptionSW->iDebug & DEBUG_Macros){
				cout << "	ptcMac[" << macro_name << "]" << endl;
			}
		}
	}
}

//==============================================================
//		}ŇĂяo
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//	
//			݂̃t@C|C^ɏĂ}NĂяo
//==============================================================
void	MMLfile::CallMacro(void)
{
	char							cData;
	size_t							i		= 0;
	size_t							n		= 0;
	string							_name	= "";
	vector<const char*>				vecMac;

	//Debugp
	if(cOptionSW->iDebug & DEBUG_Macros){
		cout << "Call Macro : ";
	}

	//------------------
	//`ꂽS}Ñ|C^擾
	if(!ptcMac.empty()){
		for(map<string,string>::iterator itMac=ptcMac.begin(), e=ptcMac.end(); itMac != e; itMac++){
			vecMac.push_back(itMac->first.c_str());
		}
	}

	//------------------
	//}N̏ƍ
	//o^Ă}N̒ŁAԒv}NTB
	i = 0;
	do{
		cData = cRead();
		_name += cData;
		n = 0;			//qbg
		if(cData > 0x20){
			vector<const char*>::iterator	it = vecMac.begin();
			while(it != vecMac.end()){
				char c = (*it)[i];
				if(c == cData){
					n++;
					it++;
				} else {
					it = vecMac.erase(it);
				}
			}
		}
		i++;
	} while(n>0);		//qbg0ɂȂ܂ŁAJԂB

	Back();										//|C^P߂B
	_name = _name.substr(0, _name.length()-1);	//P炷B

	//------------------
	//}N̑݃`FbN
	if(ptcMac.count(_name) == 0){
		Err(_T("̃}N݂͑Ă܂B"));
	}

	//------------------
	//}N̏d`FbN
	for(i=0; i < p_macro; i++){
		if(s_macro[i].name == _name){
			Err(_T("}Nœ}NĂяoĂ܂B"));
		}
	}

	//------------------
	//lXgۑ
	if(p_macro > 0){
		s_macro[p_macro-1].name = nowMacro.name;
		s_macro[p_macro-1].line = nowMacro.line;
	}

	//Debugp
	if(cOptionSW->iDebug & DEBUG_Macros){
		cout << "ptcMac[" << _name << "]@(nest = " << p_macro << " )" << endl;
	}

	nowMacro.name = _name;
	nowMacro.line = 0;

	s_macro.push_back(nowMacro);
	p_macro++;
}

//==============================================================
//		pb`̐ݒ
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//	
//			݂̃t@C|C^ɏĂ}N`B
//==============================================================
void	MMLfile::SetPatch(void)
{

	size_t			i		= GetNum();

	//d`FbN
	if(ptcPatch.count(i) != 0){
		Err(_T("Patch()ubNœԍw肳܂B"));
	}

	ptcPatch[i] =  new Patch(this, i);

}

//==============================================================
//		pb`̗L`FbN
//--------------------------------------------------------------
//	
//			size_t _no	pb`ԍ
//	Ԓl
//			bool				邩ǂ
//	
//			
//==============================================================
bool	MMLfile::ChkPatch(size_t _no)
{
	bool	result;

	if(ptcPatch.count(_no) == 0){
		result = false;
	} else {
		result = true;
	}
	return(result);
}

//==============================================================
//			݃RpC̃t@C|C^̎擾
//--------------------------------------------------------------
//	
//						
//	Ԓl
//		fstream::pos_type	݂̃t@C|C^
//==============================================================
fstream::pos_type	MMLfile::tellg(void)
{
	fstream::pos_type	i;

	if(p_macro > 0){
		i = nowMacro.line;
	} else {
		i = nowFile->tellg();
	}

	return(i);
}

//==============================================================
//			݃RpC̃t@C|C^ΓIɈړ
//--------------------------------------------------------------
//	
//			fstream::pos_type	iSize	ړl
//	Ԓl
//			
//==============================================================
void	MMLfile::StreamPointerMove(fstream::pos_type iSize)
{
	if(p_macro > 0){
		nowMacro.line = iSize;
	} else {
		nowFile->StreamPointerMove(iSize);
	}
}

//==============================================================
//			݃RpC̃t@C|C^߂
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//==============================================================
void	MMLfile::Back_one(void)
{
	if(f_macro == true){
		f_macro = false;
		if(p_macro > 0){
			s_macro[p_macro-1].name = nowMacro.name;
			s_macro[p_macro-1].line = nowMacro.line;
		}
		p_macro++;
		nowMacro.name = s_macro[p_macro-1].name;
		nowMacro.line = s_macro[p_macro-1].line;
		nowMacro.line--;
	} else {
		if(p_macro > 0){
			nowMacro.line--;
		} else {
			nowFile->Back();
		}
	}
}

void	MMLfile::Back(void)
{
	if(f_2to1==true){
		Back_one();
		Back_one();		//O̓ǂݍ݂}`oCgAQ߂B
	} else {
		Back_one();
	}
}

//==============================================================
//			PByteǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//==============================================================
char	MMLfile::read_char(void)
{
	char	cData;

	//O̓ǂݍ݂ŁA}N̏I[ɍsB
	if(f_macro == true){
		f_macro	= false;		
		s_macro.pop_back();		//}NX^bNP߂B
	}

	if(p_macro > 0){
		//}Nǂݍޏꍇ
		cData = ptcMac[nowMacro.name][nowMacro.line];
		nowMacro.line++;
		//}NI[H
		if(ptcMac[nowMacro.name].size() == nowMacro.line){
			s_macro[p_macro-1].name = nowMacro.name;
			s_macro[p_macro-1].line = nowMacro.line;
			p_macro--;
			f_macro	= true;
			if(p_macro > 0){
				nowMacro.name = s_macro[p_macro-1].name;
				nowMacro.line = s_macro[p_macro-1].line;
			}
		}
	} else {
		//t@Cǂݍޏꍇ
		cData		= nowFile->cRead();
	}

	return(cData);

}

//==============================================================
//			PByteǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//==============================================================
char	MMLfile::cRead(void)
{
	unsigned	char	cData = read_char();
	unsigned	char	cDataMSB;

	switch(cData){
		case(0x81):
			cDataMSB = read_char();
			f_2to1 = true;
			switch(cDataMSB){
				case(0x67):
					cData = '"';
					break;
				case(0x68):
					cData = '"';
					break;
				case(0x69):
					cData = '(';
					break;
				case(0x6A):
					cData = ')';
					break;
				case(0x6F):
					cData = '{';
					break;
				case(0x70):
					cData = '}';
					break;
				case(0x7B):
					cData = '+';
					break;
				case(0x7C):
					cData = '-';
					break;
				case(0x94):	//
					cData = '#';
					break;
				case(0xF3):	//
					cData = '-';
					break;
				default:
					f_2to1 = false;
					Back();
					break;
			}
			break;

		case(0x82):
			cDataMSB = read_char();
			f_2to1 = true;
			switch(cDataMSB){
				case(0x4F):
					cData = '0';
					break;
				case(0x50):
					cData = '1';
					break;
				case(0x51):
					cData = '2';
					break;
				case(0x52):
					cData = '3';
					break;
				case(0x53):
					cData = '4';
					break;
				case(0x54):
					cData = '5';
					break;
				case(0x55):
					cData = '6';
					break;
				case(0x56):
					cData = '7';
					break;
				case(0x57):
					cData = '8';
					break;
				case(0x58):
					cData = '9';
					break;
				default:
					f_2to1 = false;
					Back();
					break;
			}
			break;

		default:
			f_2to1 = false;
			break;
	}

	return(cData);
}

//==============================================================
//			PByteǂݍ݁i`FbNtj
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//	
//		P̓ǂݍ݁B
//		AAȉ̋Lqꍇ́A΂B
//			E0x20ȉ̃LN^[R[h
//			ERg
//		܂ACN[ht@C[EOF]oAÕt@Cɖ߂
//==============================================================
char	MMLfile::GetChar(void)		//1Byte̓ǂݍ
{
	unsigned	char	cData;

	do{
		cData = cRead();

		//[EOM]H
		if( eom() )
		{
			return(0);

		//[EOF]H
		} else if( eof() ){
			nowFile->close();
			delete	nowFile;
			ptcFiles.pop_back();
			nowFile = ptcFiles.back();
			iFiles--;
			//continue

		//0x20ȉ̐R[h
		} else if(cData <= 0x20){
			//continue

		//AZu^CṽRgH
		} else if(cData == ';'){
			do{
				if( eof() ){
					break;
				}
				cData = cRead();		//̃oCgǂݍ
			} while(cData != 0x0A);
		
		//b^CṽRgH
		} else 	if(cData == '/'){
			cData = cRead();		//̃oCgǂݍ
			switch(cData){

				//PsRg
				case('/'):
					do{
						if( eof() ){
							break;
						}
						cData = cRead();		//̃oCgǂݍ
					}while(cData != 0x0A);
					break;

				//͈̓Rg
				case('*'):
					do{
						do{
							cData = cRead();		//̃oCgǂݍ
							if(eof()){
								Err(_T("RgI[ */ ܂łB"));
							}
						}while(cData != '*');
						cData = cRead();
						Back();					//StreamPointerAdd(-1);
					} while(cData != '/');
							cRead();			//StreamPointerAdd(+1); B
					break;

				//ȊO
				default:
					Err(_T("'/'P܂łB"));
					break;
			}

		//[EOF]łARgłꍇB
		} else {
			break;		//while(1)  break;
		}

	} while(true);

	return(cData);
}

//==============================================================
//			{邩`FbN
//--------------------------------------------------------------
void	MMLfile::ChkBlockStart(void)
{
	// { ̌
	while(1){
		char cData = GetChar();
		if(cData == '{'){
			break;
		} else if(cData == '='){
			//=͋B
			continue;
		} else {
			//ȊO̓G[ɂ
			Err(_T("ubN̊Jn{܂łB"));
		}
	}
}

//==============================================================
//			[EOF]̃`FbN
//--------------------------------------------------------------
void	MMLfile::ChkEOF(void)
{
	// } OɁA[EOF]G[
	if(eof()){
		Err(_T("ubN̏I[`}'܂łB"));
	}
}

//==============================================================
//			[EOF]̑O}邩`FbN
//--------------------------------------------------------------
//	
//			chae	cData*	ǂݍ񂾃f[^i[|C^
//	Ԓl
//			bool			ǂݍ񂾃f[^`}'łfalse
//==============================================================
bool	MMLfile::GetChar_With_ChkEOF(char* cData)
{
	//ǂݍ
	*cData = GetChar();

	ChkEOF();

	//`}'̃`FbN
	return(*cData != '}');
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			bool	f_ESC	GXP[vV[PX̉
//							true: ESCV[PX ok
//	Ԓl
//			string			ǂݍ񂾕
//	
//			MML""ň͂܂ꂽ擾B
//==============================================================
void	MMLfile::GetString(string* _str, bool	f_ESC)
{
	int		i;
	char	cData;

	cData = GetChar();
	if(cData != '"'){
			Err(_T("Jn\"܂łB"));
	}

	while('"' != (cData = cRead())){
		if(eof()){
			Err(_T("I\"܂łB"));
		}
		if((f_ESC == true) && (cData == '\\')){
			cData = GetChar();
			if(eof()){
				Err(_T("I\"܂łB"));
			}
			switch(cData){
				case('a'):
					cData = '\a';
					break;
				case('b'):
					cData = '\b';
					break;
				case('f'):
					cData = '\f';
					break;
				case('n'):
					cData = '\n';
					break;
				case('r'):
					cData = '\r';
					break;
				case('t'):
					cData = '\t';
					break;
				case('v'):
					cData = '\v';
					break;
				case('\''):
					cData = '\'';
					break;
				case('\"'):
					cData = '\"';
					break;
				case('\\'):
					cData = '\\';
					break;
				case('\?'):
					cData = '\?';
					break;
				case('x'):
					i = GetHex();
					cData = (char)(i & 0xFF);
					break;
				case('0'):
				case('1'):
				case('2'):
				case('3'):
				case('4'):
				case('5'):
				case('6'):
				case('7'):
					Back();
					i = GetOct();
					cData = (char)(i & 0xFF);
					break;
				default:
					*_str += '\\';
					break;
			}
		}
		*_str += cData;
	}
}

//==============================================================
//			lǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//	
//			MML()ň͂܂ꂽ擾B
//==============================================================
int	MMLfile::GetNum(void)
{
	char	cData;
	int		iResult;

	cData = GetChar();
	if(cData != '('){
		Err(_T("lJn(܂łB"));
	}

	iResult = GetInt();

	cData = GetChar();
	if(cData != ')'){
		Err(_T("lI)܂łB"));
	}

	return(iResult);
}

//==============================================================
//			lǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//==============================================================
int		MMLfile::GetInt(void)
{
				bool	neg;				//
				int		iResult;			//Z
	unsigned	char	cData = GetChar();

	//16i
	if(cData == '$'){
		neg		= chkSigh();
		iResult = GetHex();

	//Qi
	} else if(cData == '%'){
		neg		= chkSigh();
		iResult = GetBin();

	//10i
	} else if(((cData >= '0') && (cData <= '9')) || (cData == '-') || (cData == '+')){
		Back();		//|C^P߂
		neg		= chkSigh();
		iResult = GetDec();

	} else {
		Err(_T("lȊOw肳܂B"));
	}

	//
	if(neg == true){
		iResult = -iResult;
	}

	return(iResult);
}

//--------------------------------------------------------------
bool	MMLfile::chkSigh(void)
{
				bool	neg;
	unsigned	char	cData = GetChar();

	switch(cData){
		case('-'):
			neg = true;
			break;
		case('+'):
			neg = false;
			break;
		default:
			Back();		//|C^P߂
			neg = false;
			break;
	}
	return(neg);
}

//--------------------------------------------------------------
int	MMLfile::GetHex(void)
{
				int		iResult = 0;			//Z
	unsigned	char	cData = GetChar();

	while(((cData >= '0') && (cData <= '9')) || ((cData >= 'a') && (cData <= 'f')) || ((cData >= 'A') && (cData <= 'F'))){
		iResult <<= 4;
		if((cData >= '0') && (cData <= '9')){
			iResult += (unsigned int)cData - 0x30;
		} else if((cData >= 'A') && (cData <= 'F')){
			iResult += (unsigned int)cData - 0x41 + 10;
		} else if((cData >= 'a') && (cData <= 'f')){
			iResult += (unsigned int)cData - 0x61 + 10;
		}
		cData	 = cRead();
	}

	//|C^P߂
	Back();							//	StreamPointerAdd(-1);

	return(iResult);
}

//--------------------------------------------------------------
int	MMLfile::GetDec(void)
{
				int		iResult = 0;			//Z
	unsigned	char	cData = GetChar();		

	while((cData >= '0') && (cData <= '9')){
		iResult *= 10;
		iResult += (unsigned int)cData - 0x30;
		cData	 = cRead();
	}

	//|C^P߂
	Back();							//	StreamPointerAdd(-1);

	return(iResult);
}

//--------------------------------------------------------------
int	MMLfile::GetOct(void)
{
				int		iResult = 0;			//Z
	unsigned	char	cData = GetChar();		

	while((cData >= '0') && (cData <= '7')){
		iResult <<= 3;
		iResult += (unsigned int)cData - 0x30;
		cData	 = cRead();
	}

	//|C^P߂
	Back();							//	StreamPointerAdd(-1);

	return(iResult);
}

//--------------------------------------------------------------
int	MMLfile::GetBin(void)
{
				int		iResult = 0;			//Z
	unsigned	char	cData = GetChar();		

	while((cData >= '0') && (cData <= '1')){
		iResult <<= 1;
		iResult += (unsigned int)cData - 0x30;
		cData	 = cRead();
	}

	//|C^P߂
	Back();							//	StreamPointerAdd(-1);

	return(iResult);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			int		LڂȂꍇ̉[tick]
//	Ԓl
//			int		[tick]
//	
//		ǂݍށit_tj
//==============================================================
int	MMLfile::readLength(int DefaultLength){

	char	cData;				//ǂݍݗp
	int		iLength;			// [tick]
	int		iDot;				//t_vZp [tick]
	int		iMod;
	int		i;

	//ǂݍ
	cData = GetChar();

	//|C^P߂
	Back();							//StreamPointerAdd(-1);

	//Length
	if(((cData >= '0') && (cData <= '9')) || (cData == '.')){
		if((cData >= '0') && (cData <= '9')){
			i = GetInt();
			if(i==0){
				Err(_T("0͎g܂B"));
			}
			iLength = (timebase * 4) / i;
			iMod	= (timebase * 4) % i;
			if(iMod != 0){
				Warning(_T("̌vZŊ؂܂łB_͐؎̂Ă܂B"));
			}
		} else {
			//t_LqꍇB
			if(DefaultLength == -1){
				Err(_T("LqĉB"));
			}
			iLength = DefaultLength;
		}

		iDot	= iLength;
		//t_
		while((cData = cRead()) == '.'){
			if(iLength == -1){
				Err(_T("̋LqȂɕt_gꍇ́AOl R}hLqĉB"));
			}
			iMod = (iDot & 0x01);
			iDot >>= 1;
			if(iMod != 0){
				Warning(_T("t_̌vZŊ؂܂łB_͐؎̂Ă܂B"));
			}
			iLength += iDot;
		};
		Back();							//StreamPointerAdd(-1);



	//Tick
	} else if (cData == '%'){
		GetChar();	//1i߂B
		iLength = GetInt();

	} else {
		//Ȃꍇ
		if(DefaultLength == -1){
			Err(_T("LqĉB"));
		}
		iLength = -1;
	}

	return(iLength);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			int		LڂȂꍇ̉[tick]
//	Ԓl
//			int		ǂݍ񂾐l
//					ĂȂꍇ́A -1 ԂB
//==============================================================
int		MMLfile::GetLength(int DefaultLength)	//
{
	char	cData;				//ǂݍݗp
	int		iLength;			// [tick]
	int		iCalc;
	bool	add;

	//ǂݍ
	iLength = readLength(DefaultLength);

	//̉Z
	cData = cRead();
	while((cData == '-') || (cData == '~') || (cData == '+') || ((iTieMode == 1) && (cData == '^'))){
		if(iLength == -1){
			iLength = DefaultLength;
		}

		//ŌvZ镄̃`FbN
		if((cData == '+') || (cData == '^')){
			add = true;
		} else {
			add = false;
		}
		iCalc = readLength(DefaultLength);

		if(iCalc == -1){
		//	Warning(_T("̉ZlɐlȊOw肳Ă܂B"));
			iCalc = DefaultLength;
		}

		if(add == true){
			iLength += iCalc;	// '+'  '^' ͉Z
		} else {
			iLength -= iCalc;	// '-'  '~' ͌Z
		}
		cData = cRead();
	};
	Back();							//StreamPointerAdd(-1);

	if(iLength == -1){
		return(iLength);
	}

	if((iLength < 1) || (iLength > 255)){
		Err(_T("́A%1i96j`%255i1+1+2+8j̊ԂŎw肵ĉB255[tick]𒴂ꍇ̓^C`&', `^'gĉB"));
	}

	return(iLength);
}

//==============================================================
//		R}hID̎擾
//--------------------------------------------------------------
//	
//		Command_Info*		_command
//		size_t				_size
//	Ԓl
//		int			R}hR[h@i-1unknown commandj
//==============================================================
int	MMLfile::GetCommandID(const Command_Info _command[], size_t _size)
{
	fstream::pos_type	ptCmdEnd	= tellg();
			size_t	i = 0;					//p
			size_t	n = 0;					//qbgp
			int		iResult = -1;

	map<const char*, int>	mapCmdInfo;

	nowCommand.clear();

	//p̃IuWFNg쐬
	for(i=0; i<_size; i++){
		mapCmdInfo[_command[i].str] = _command[i].id;
	}

	//
	i = 0;
	do{
		map<const char*, int>::iterator	it = mapCmdInfo.begin();
		char cData = cRead();
		n = 0;
		while(it != mapCmdInfo.end()){
			char c = (it->first)[i];
			if(c == cData){
				n++;
				it++;
			} else if(c == 0){
				Back();
				ptCmdEnd = tellg();				//qbgƂ̃t@C|C^L
				cRead();
				nowCommand.assign(it->first);	//qbgR}h
				iResult = it->second;			//qbgR}hID
				mapCmdInfo.erase(it++);
			} else {
				mapCmdInfo.erase(it++);
			}
		}
		i++;
	} while((n>0) && (f_macro == false));	//qbg0ɂȂ܂ŁAJԂB

	if(f_macro == true){
		Back();
	}
	StreamPointerMove(ptCmdEnd);

	return(iResult);
}

//==============================================================
//		G[
//--------------------------------------------------------------
void	MMLfile::ErrUnknownCmd()
{
	char	cData = cRead();

	nowCommand.assign(1, cData);
	Err(_T("Unknown Command"));
}

//==============================================================
//		G[
//--------------------------------------------------------------
//	
//		const	_CHAR	msg[]	G[bZ[W
//	Ԓl
//				
//==============================================================
void	MMLfile::Err(const _CHAR msg[])
{
	_OMP_SET_LOCK(lock_cout)
	f_error = true;

	//G[e\
	if(cOptionSW->fErr == true){
		//݂̃t@CƁAs\
		cerr << "[ ERROR ] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << "): " << nowCommand << " : ";
		_CERR << msg << endl;
	} else {
		//݂̃t@CƁAs\
		cout << "[ ERROR ] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << "): " << nowCommand << " : ";
		_COUT << msg << endl;
	}
	_OMP_UNSET_LOCK(lock_cout)

	//ُI
	nsc_exit(EXIT_FAILURE);
}

//--------------------------------------------------------------
void	MMLfile::Err(const string& str)
{
	_OMP_SET_LOCK(lock_cout)
	f_error = true;

	//G[e\
	if(cOptionSW->fErr == true){
		//݂̃t@CƁAs\
		cerr << "[ ERROR ] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << "): " << nowCommand << " : " << str.c_str() << endl;
	} else {
		//݂̃t@CƁAs\
		cout << "[ ERROR ] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << "): " << nowCommand << " : " << str.c_str() << endl;
	}
	_OMP_UNSET_LOCK(lock_cout)

	//ُI
	nsc_exit(EXIT_FAILURE);
}

//==============================================================
//		[jO
//--------------------------------------------------------------
//	
//		const	_CHAR	msg[]	[jObZ[W
//	Ԓl
//				
//==============================================================
void	MMLfile::Warning(const _CHAR msg[])
{
	_OMP_SET_LOCK(lock_cout)
	//[jOe\
	if(cOptionSW->fErr == true){
		//݂̃t@CƁAs\
		cerr << "[WARNING] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << "): " << nowCommand << " : ";
		_CERR << msg << endl;
	} else {
		//݂̃t@CƁAs\
		cout << "[WARNING] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << "): " << nowCommand << " : ";
		_COUT << msg << endl;
	}
	_OMP_UNSET_LOCK(lock_cout)
}

//--------------------------------------------------------------
void	MMLfile::Warning(const string& str)
{
	_OMP_SET_LOCK(lock_cout)
	//[jOe\
	if(cOptionSW->fErr == true){
		//݂̃t@CƁAs\
		cerr << "[WARNING] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << "): " << nowCommand << " : " << str.c_str() << endl;
	} else {
		//݂̃t@CƁAs\
		cout << "[WARNING] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << "): " << nowCommand << " : " << str.c_str() << endl;
	}
	_OMP_UNSET_LOCK(lock_cout)
}
