/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "MusicFile.h"

/****************************************************************/
/*					O[oϐiNXǁEEEj		*/
/****************************************************************/
extern	OPSW*			cOptionSW;	//IvVւ̃|C^ϐ

#ifdef _OPENMP
	extern	omp_lock_t		lock_cout;
#endif

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*			MML			llkt@C̃IuWFNg
//		string				_code		NR[hi*.binj̃t@C
//		const		_CHAR	_strName[]	IuWFNg
//	Ԓl
//				
//==============================================================
MusicFile::MusicFile(MMLfile* MML, string _code, const _CHAR _strName[]):
	MusicItem(_strName),
	Header(_code),
	cDPCMinfo(NULL)
{

	try {

	//----------------------
	//Localϐ

//	萔`
enum	Command_ID_MusicFile {
	//for NSF output
	id_Title,
	id_Composer,
	id_Copyright,
	id_Maker,
	id_Text,
	id_plst,
	id_psfx,
	id_mixe,
	id_vrc7_chg,
	id_OffsetPCM,
	id_Code,
	id_External,
	id_Bank,

	//for ASM output
	id_SegmentSEQ,
	id_SegmentPCM,
	id_Label,
	id_Priority,

	//General
	id_include,
	id_timebase,
	id_OctaveReverse,
	id_QReverse,
	id_bgm_num,
	id_se_num,
	id_releaseVolume,
	id_repeatMode,
	id_TieMode,
	id_offset_Ei,
	id_offset_Ev,
	id_offset_En,
	id_offset_Em,
	id_QMax,
	id_rest,
	id_wait,

	//Block
	id_DPCM,
	id_FDSC,
	id_FDSM,
	id_VRC7,
	id_N163,
	id_Envelop,
	id_Vibrato,
	id_Macro,
	id_Sub,
	id_BGM,
	id_SE,
	id_Patch,

	id_Null
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		//for NSF output
		{	"#Title",			id_Title		},
		{	"#title",			id_Title		},
		{	"Ȗ",				id_Title		},
		{	"#Composer",		id_Composer		},
		{	"#composer",		id_Composer		},
		{	"Ȏ",			id_Composer		},
		{	"",				id_Composer		},
		{	"#Copyright",		id_Copyright	},
		{	"#copyright",		id_Copyright	},
		{	"",				id_Copyright	},
		{	"쌠",			id_Copyright	},
		{	"#Maker",			id_Maker		},
		{	"#maker",			id_Maker		},
		{	"#Ripper",			id_Maker		},
		{	"#ripper",			id_Maker		},
		{	"",			id_Maker		},
		{	"#Text",			id_Text			},
		{	"#text",			id_Text			},
		{	"eLXg",			id_Text			},
		{	"#PlayList",		id_plst			},
		{	"#Plst",			id_plst			},
		{	"#plst",			id_plst			},
		{	"y",			id_plst			},
		{	"ȏ",				id_plst			},
		{	"#PlaySfx",			id_psfx			},
		{	"#Psfx",			id_psfx			},
		{	"#psfx",			id_psfx			},
		{	"ʉ",		id_psfx			},
		{	"#Mixe",			id_mixe			},
		{	"#mixe",			id_mixe			},
		{	"#Mix",				id_mixe			},
		{	"#mix",				id_mixe			},
		{	"#VRC7",			id_vrc7_chg		},
		{	"#OffsetPCM",		id_OffsetPCM	},	//Offset Address of PCM
		{	"#offsetPCM",		id_OffsetPCM	},	//Offset Address of PCM
		{	"#Code",			id_Code			},
		{	"#code",			id_Code			},
		{	"R[h",			id_Code			},
		{	"#External",		id_External		},
		{	"#external",		id_External		},
		{	"#Bank",			id_Bank			},
		{	"#bank",			id_Bank			},
		{	"oN",			id_Bank			},
		//for ASM output
		{	"#SegmentPCM",		id_SegmentPCM	},	//Segment name for PCM
		{	"#segmentPCM",		id_SegmentPCM	},
		{	"#SegmentSEQ",		id_SegmentSEQ	},	//Segment name for Sequence
		{	"#segmentSEQ",		id_SegmentSEQ	},
		{	"#Segment",			id_SegmentSEQ	},	//Segment name for Sequence
		{	"#segment",			id_SegmentSEQ	},
		{	"#Label",			id_Label		},
		{	"#label",			id_Label		},

		//General
		{	"#Include",			id_include		},
		{	"#include",			id_include		},
		{	"ǂ",				id_include		},
		{	"#Timebase",		id_timebase		},
		{	"#timebase",		id_timebase		},
		{	"#OctaveReverse",	id_OctaveReverse},
		{	"#octaveReverse",	id_OctaveReverse},
		{	"#QReverse",		id_QReverse		},
		{	"#qReverse",		id_QReverse		},
		{	"#BGM",				id_bgm_num		},
		{	"#bgm",				id_bgm_num		},
		{	"y",			id_bgm_num		},
		{	"#SE",				id_se_num		},
		{	"#se",				id_se_num		},
		{	"ʉ",			id_se_num		},
		{	"#releaseVolume",	id_releaseVolume},
		{	"#ReleaseVolume",	id_releaseVolume},
		{	"#repeatMode",		id_repeatMode	},
		{	"#RepeatMode",		id_repeatMode	},
		{	"#TieMode",			id_TieMode		},
		{	"#tieMode",			id_TieMode		},	
		{	"#OffsetE@",		id_offset_Ei	},
		{	"#offsetE@",		id_offset_Ei	},
		{	"#OffsetEv",		id_offset_Ev	},
		{	"#offsetEv",		id_offset_Ev	},
		{	"#OffsetEm",		id_offset_Em	},
		{	"#offsetEm",		id_offset_Em	},
		{	"#OffsetEn",		id_offset_En	},
		{	"#offsetEn",		id_offset_En	},
		{	"#Priority",		id_Priority		},
		{	"#priority",		id_Priority		},
		{	"#QMax",			id_QMax			},
		{	"#Qmax",			id_QMax			},
		{	"#Rest",			id_rest			},
		{	"#rest",			id_rest			},
		{	"#Wait",			id_wait			},
		{	"#wait",			id_wait			},
		//Block
		{	"DPCM",				id_DPCM			},
		{	"FDSC",				id_FDSC			},
		{	"FDSM",				id_FDSM			},
		{	"VRC7",				id_VRC7			},
		{	"N163",				id_N163			},
		{	"Envelope",			id_Envelop		},
		{	"envelope",			id_Envelop		},
		{	"Envelop",			id_Envelop		},
		{	"envelop",			id_Envelop		},
		{	"Gx[v",		id_Envelop		},
		{	"ru[g",		id_Vibrato		},
		{	"Sub",				id_Sub			},
		{	"sub",				id_Sub			},
		{	"BGM",				id_BGM			},
		{	"bgm",				id_BGM			},
		{	"y",				id_BGM			},
		{	"SE",				id_SE			},
		{	"se",				id_SE			},
		{	"ʉ",			id_SE			},
		{	"Patch",			id_Patch		},

		//for 1 command
		{	"D",				id_DPCM			},
		{	"FC",				id_FDSC			},
		{	"FM",				id_FDSM			},
		{	"O",				id_VRC7			},
		{	"V",				id_VRC7			},
		{	"N",				id_N163			},
		{	"E",				id_Envelop		},
		{	"S",				id_Sub			},
		{	"P",				id_Patch		},
		{	"$",				id_Macro		},

		//for mck/ppmck
		{	"@DPCM",			id_DPCM			},
		{	"@FM",				id_FDSC			},
		{	"@MW",				id_FDSM			},
		{	"@OP",				id_VRC7			},
		{	"@N",				id_N163			},
		{	"@E",				id_Envelop		},

		{	"@",				id_Null			},
	};

					size_t		i;
		string		msg;

		map<size_t,	Envelop*	>::iterator	itEnvelop;
		map<size_t,	BGM*		>::iterator	itBGM;
		map<size_t,	SE*			>::iterator	itSE;
		map<size_t,	Sub*		>::iterator	itSub;

	//	iSize = 0;

		//̃IuWFNg͕KgiœKΏۊOjB
		setUse();

		//^f[^`FbNp̃tO
		f_is_track_time		= false;
		f_is_track_fade		= false;
		f_is_track_label	= false;
		f_is_track_auth		= false;

		do{
			//Pǂݍ݁iRg`FbNAincludet@C̏I[`FbNj
	//		cData = MML->GetChar();
			MML->GetChar();

			//[EOF]`FbN
			if( MML->eom() ){
				break;
			}

			//P߂
			MML->Back();

			//R}h̃`FbN
			switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){
				//for NSF output
				case(id_Code):
					Header.Set_RomCode(MML);
					break;
				case(id_Title):
					Header.Set_Title(MML);
					break;
				case(id_Composer):
					Header.Set_Composer(MML);
					break;
				case(id_Copyright):
					Header.Set_Copyright(MML);
					break;
				case(id_Maker):
					Header.Set_Maker(MML);
					break;
				case(id_Text):
					Header.Text_Append(MML);
					break;
				case(id_plst):
					Header.Set_plst(MML);
					break;
				case(id_psfx):
					Header.Set_psfx(MML);
					break;
				case(id_mixe):
					Header.Set_mixe(MML);
					break;
				case(id_vrc7_chg):
					Header.Ser_VRC7(MML);
					break;
				case(id_OffsetPCM):
					Header.Set_OffsetPCM(MML);
					break;
				case(id_External):
					Header.Set_External(MML);
					break;
				case(id_Bank):
					Header.Set_Bank();
					break;
				//for ASM output
				case(id_SegmentSEQ):
					Header.Set_SegmentSEQ(MML);
					break;
				case(id_SegmentPCM):
					Header.Set_SegmentPCM(MML);
					break;
				case(id_Label):
					Header.Set_Label(MML);
					break;
				//General
				case(id_include):
					MML->include();
					break;
				case(id_bgm_num):
					Header.Set_Number_BGM(MML);
					break;
				case(id_se_num):
					Header.Set_Number_SE(MML);
					break;
				case(id_timebase):
					MML->timebase = MML->GetInt();	//́AMMLt@C̑B
					break;
				case(id_OctaveReverse):
					MML->octave_reverse = true;		//́AMMLt@C̑B
					break;
				case(id_QReverse):
					MML->q_reverse = true;			//́AMMLt@C̑B
					break;
				case(id_releaseVolume):
					MML->iReleaseVolume	=  MML->GetInt();
					if((MML->iReleaseVolume<0) || (MML->iReleaseVolume>15)){
						MML->Err(_T("#ReleaseVolumeR}h́A0`15͈̔͂Ŏw肵ĂB"));
					}
					break;
				case(id_repeatMode):
					MML->iRepeatMode	=  MML->GetInt();
					if((MML->iRepeatMode<0) || (MML->iRepeatMode>2)){
						MML->Err(_T("#RepeatModeR}h́A0`2͈̔͂Ŏw肵ĂB"));
					}
					break;
				case(id_TieMode):
					MML->iTieMode	=  MML->GetInt();
					if((MML->iTieMode<0) || (MML->iTieMode>1)){
						MML->Err(_T("#TieModeR}h́A0`1͈̔͂Ŏw肵ĂB"));
					}
					break;
				case(id_offset_Ei):
					MML->offset_Ei = MML->GetInt();
					break;
				case(id_offset_Ev):
					MML->offset_Ev = MML->GetInt();
					break;
				case(id_offset_En):
					MML->offset_En = MML->GetInt();
					break;
				case(id_offset_Em):
					MML->offset_Em = MML->GetInt();
					break;
				case(id_Priority):
					i = MML->GetInt();
					if((i<0) || (i>3)){
						MML->Err(_T("#priorityR}h́A0`3͈̔͂Ŏw肵ĂB"));
					} else {
						MML->priority = (unsigned char)i;
					}
					break;
				case(id_QMax):
					MML->QMax = MML->GetInt();
					break;
				case(id_rest):
					MML->rest = MML->GetInt();
					if((MML->rest<0) || (MML->rest>3)){
						MML->Err(_T("#RestR}h́A0`3͈̔͂Ŏw肵ĂB"));
					}
					break;
				case(id_wait):
					MML->wait = MML->GetInt();
					if((MML->rest<0) || (MML->rest>3)){
						MML->Err(_T("#WaitR}h́A0`3͈̔͂Ŏw肵ĂB"));
					}
					break;
				case(id_Macro):
					MML->SetMacro(0);
					break;
				case(id_Patch):
					MML->SetPatch();
					break;
				//MML
				case(id_DPCM):
					if(cDPCMinfo != NULL){
						MML->Err(_T("DPCMubN͂P܂łłB"));
					}
					cDPCMinfo = new DPCMinfo(MML, Header.bank);
					if(cDPCMinfo->isError() == true){
						f_error = true;
					} else {
						ptcItem.push_back(cDPCMinfo);
					}
					break;
				case(id_FDSC):
					{
						FDSC*	_fdsc;
						i = MML->GetNum();
						//d`FbN
						if(ptcFDSC.count(i) != 0){
							MML->Err(_T("FDSC()ubNœԍw肳܂B"));
						}
						_fdsc = new FDSC(MML, i);
						ptcItem.push_back(_fdsc);
						ptcFDSC[i] = _fdsc;
					}
					break;
				case(id_FDSM):
					{
						FDSM*	_fdsm;
						i = MML->GetNum();
						//d`FbN
						if(ptcFDSM.count(i) != 0){
							MML->Err(_T("FDSM()ubNœԍw肳܂B"));
						}
						_fdsm = new FDSM(MML, i);
						ptcItem.push_back(_fdsm);
						ptcFDSM[i] = _fdsm;
					}
					break;
				case(id_VRC7):
					{
						VRC7*	_vrc7;
						i = MML->GetNum();
						//d`FbN
						if(ptcVRC7.count(i) != 0){
							MML->Err(_T("VRC7()ubNœԍw肳܂B"));
						}
						_vrc7 = new VRC7(MML, i);
						ptcItem.push_back(_vrc7);
						ptcVRC7[i] = _vrc7;
					}
					break;
				case(id_N163):
					{
						N163*	_n163;
						i = MML->GetNum();
						//d`FbN
						if(ptcN163.count(i) != 0){
							MML->Err(_T("N163()ubNœԍw肳܂B"));
						}
						_n163 = new N163(MML, i);
						ptcItem.push_back(_n163);
						ptcN163[i] = _n163;
					}
					break;
				case(id_Envelop):
					{
						Envelop*	_env;
						i = MML->GetNum();
						//d`FbN
						if(ptcEnv.count(i) != 0){
							MML->Err(_T("Envelope()ubNœԍw肳܂B"));
						}
						_env = new Envelop(MML, i);
						ptcItem.push_back(_env);
						ptcEnv[i] = _env;
					}
					break;
				case(id_Vibrato):
					{
						Envelop*	_env;
						MML->offset_Em = 1000000;
						i = MML->GetNum() + MML->offset_Em;
						//d`FbN
						if(ptcEnv.count(i) != 0){
							MML->Err(_T("ru[g()ubNœԍw肳܂B"));
						}
						_env = new Envelop(MML, i);
						ptcItem.push_back(_env);
						ptcEnv[i] = _env;
					}
					break;
				case(id_Sub):
					{
						Sub*	_sub;
						i = MML->GetNum();
						//d`FbN
						if(ptcSub.count(i) != 0){
							MML->Err(_T("Sub()ubNœԍw肳܂B"));
						}
						//͈̓`FbN
						_sub = new Sub(MML, i);
						ptcItem.push_back(_sub);
						ptcSub[i] = _sub;
					}
					break;
				case(id_BGM):
					{
						BGM*	_bgm;
						i = MML->GetNum();
						//d`FbN
						if(ptcBGM.count(i) != 0){
							MML->Err(_T("BGM()ubNœԍw肳܂B"));
						}
						//͈̓`FbN
						if((Header.iBGM <= i) || (i<0)){
							MML->Err(_T("BGM()ubNŎwł͈͂𒴂Ă܂B\n#BGM̐lmFĂB"));
						}
						_bgm = new BGM(MML, i);
						ptcItem.push_back(_bgm);
						ptcBGM[i] = _bgm;
						//^f[^`FbN
						if(_bgm->isLabel() == true){
							f_is_track_label = true;
						}
						if(_bgm->isAuthor() == true){
							f_is_track_auth	= true;
						}
						if(_bgm->isTime() == true){
							f_is_track_time	= true;
						}
						if(_bgm->isFade() == true){
							f_is_track_fade	= true;
						}
					}
					break;
				case(id_SE):
					{
						SE*	_se;
						i = MML->GetNum();
						//d`FbN
						if(ptcSE.count(i) != 0){
							MML->Err(_T("SE()ubNœԍw肳܂B"));
						}
						//͈̓`FbN
						if((Header.iSE <= i) || (i<0)){
							MML->Err(_T("SE()ubNŎwł͈͂𒴂Ă܂B\n#SE̐lmFĂB"));
						}
						_se = new SE(MML, i);
						ptcItem.push_back(_se);
						ptcSE[i] = _se;
						//^f[^`FbN
						if(_se->isLabel() == true){
							f_is_track_label = true;
						}
						if(_se->isAuthor() == true){
							f_is_track_auth	= true;
						}
						if(_se->isTime() == true){
							f_is_track_time	= true;
						}
						if(_se->isFade() == true){
							f_is_track_fade	= true;
						}
					}
					break;
				case(id_Null):
					break;
				default:
					MML->ErrUnknownCmd();
					break;
			}
			
		} while( !MML->eom() );

		//==============================
		//Check
		if( Header.iBGM + Header.iSE > 255){
			MML->Err(_T("BGMSE̐v255z܂B"));
		}

		for(size_t n=0, e=Header.iBGM; n<e; ++n){
			if(ptcBGM.count(n) == 0){
				MML->Err(_T("BGMf[^܂B"));
			};
		}

		for(size_t n=0, e=Header.iSE; n<e; ++n){
			if(ptcSE.count(n) == 0){
				MML->Err(_T("SE f[^܂B"));
			};
		}

	} catch (int no) {
		nsc_ErrMsg(no);
		f_error = true;
	} catch (const exception& e){
		nsc_ErrMsg(e);
		f_error = true;
	} catch (const _CHAR *stErrMsg) {
		nsc_ErrMsg(stErrMsg);
		f_error = true;
	}
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MusicFile::~MusicFile(void)
{
}

//==============================================================
//		gpȂIuWFNǧ폜
//		ȂATickJEg
//		A^f[^W
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::TickCount(void)
{
	//==============================
	//Tick Count & œK̂߂̏W
	//i͕񉻂ȂŁAԂɏ鎖j

	for(size_t n=0, e=Header.iBGM; n<e; ++n){
		if(ptcBGM.count(n) == 1){
			BGM* _BGM = ptcBGM[n];
			_COUT << _T("---- BGM(") << n << _T(") ----") <<endl;
			_BGM->TickCount(this);				//JEeBOȂAsvȃR}h`FbN
			if(f_is_track_label == true){
				Header.Set_tlbl(_BGM->getLabel());
			}
			if(f_is_track_auth == true){
				Header.Set_taut(_BGM->getAuthor());
			}
			if(f_is_track_time == true){
				Header.Set_time(_BGM->getTime());
			}
			if(f_is_track_fade == true){
				Header.Set_fade(_BGM->getFade());
			}
		}
	}

	for(size_t n=0, e=Header.iSE; n<e; ++n){
		if(ptcSE.count(n) == 1){
			SE*	_SE = ptcSE[n];
			_COUT << _T("---- SE(") << n << _T(") ----") <<endl;
			_SE->TickCount(this);				//JEeBOȂAsvȃR}h`FbN
			if(f_is_track_label == true){
				Header.Set_tlbl(_SE->getLabel());
			}
			if(f_is_track_auth == true){
				Header.Set_taut(_SE->getAuthor());
			}
			if(f_is_track_time == true){
				Header.Set_time(_SE->getTime());
			}
			if(f_is_track_fade == true){
				Header.Set_fade(_SE->getFade());
			}
		}
	}


	//==============================
	//Metadata

	Header.Set_text();	//text
	Header.Set_auth();	//auth
	Header.Set_NEND();	//NEND


	//==============================
	//œK
	//iJEǵA񉻂ėǂj

	//G[ĂœK͂ȂB
	if (f_error == false) {

		//----------------------
		//svȃR}h̍폜
		if (cOptionSW->flag_OptSeq == true) {		//R}h̍œKAœKȂB

			_OMP_PARALLEL
			{
				_OMP_FOR_NOWAIT
				for (int n = 0; n < Header.iBGM; ++n) {
					ptcBGM[n]->clear_Optimize();
				}

				_OMP_FOR_NOWAIT
				for (int n = 0; n < Header.iSE; ++n) {
					ptcSE[n]->clear_Optimize();
				}

				_OMP_SINGLE
				for (map<size_t, Sub*>::iterator it = ptcSub.begin(), e = ptcSub.end(); it != e; ++it) {
					it->second->clear_Optimize();
				}
			}
		}

		//----------------------
		//gĂȂ`̍폜
		if (cOptionSW->flag_OptObj == true) {		//`̍œKAœKȂB

			_OMP_PARALLEL_SECTIONS
			{
				//Gx[v
				_OMP_SECTION
				{
					for (map<size_t, Envelop*>::iterator it = ptcEnv.begin(), e = ptcEnv.end(); it != e; ++it) {
						it->second->clear_Optimize();
					}
				}

				//FDSC
				_OMP_SECTION
				{
					for (map<size_t, FDSC*>::iterator it = ptcFDSC.begin(), e = ptcFDSC.end(); it != e; ++it) {
						it->second->clear_Optimize();
					}
				}

				//FDSM
				_OMP_SECTION
				{
					for (map<size_t, FDSM*>::iterator it = ptcFDSM.begin(), e = ptcFDSM.end(); it != e; ++it) {
						it->second->clear_Optimize();
					}
				}

				//VRC7
				_OMP_SECTION
				{
					for (map<size_t, VRC7*>::iterator it = ptcVRC7.begin(), e = ptcVRC7.end(); it != e; ++it) {
						it->second->clear_Optimize();
					}
				}

				//N163
				_OMP_SECTION
				{
					for (map<size_t, N163*>::iterator it = ptcN163.begin(), e = ptcN163.end(); it != e; ++it) {
						it->second->clear_Optimize();
					}
				}
			}
		}
	}
}

//==============================================================
//		PCM̃ItZbgAhXvZ
//--------------------------------------------------------------
//	
//		unsigned	int	iMusSize	V[PX̃TCY
//	Ԓl
//		unsigned	int	PCM̍vTCY
//==============================================================
size_t	MusicFile::SetDPCMOffset(size_t iMusSize)
{
				size_t	i;
	unsigned	char	mus_bank = (unsigned char)(iMusSize >> 12);

	if((iMusSize & 0x0FFF) != 0){
		mus_bank++;
	}

	dpcm_code.clear();
	if(cDPCMinfo != NULL){
		cDPCMinfo->getDPCMCode(&dpcm_code);
		i = cDPCMinfo->setDPCMoffset(Header.offsetPCM, mus_bank+3);
	} else {
		i = Header.offsetPCM;
	}

	return(i - Header.offsetPCM);
}

//==============================================================
//		AhX肷B
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//	
//				Fix_AddresśAegbNŁA񉻂B
//==============================================================
void	MusicFile::Fix_Address(void)
{
	for (size_t n = 0; n < Header.iBGM; ++n) {
		ptcBGM[n]->Fix_Address(this);	//̐ŕ[]
	}

	for (size_t n = 0; n < Header.iSE; ++n) {
		ptcSE[n]->Fix_Address(this);	//̐ŕ[]
	}

	for (map<size_t, Sub*>::iterator it = ptcSub.begin(), e = ptcSub.end(); it != e; ++it) {
		it->second->Fix_Address(this);	//̐ŕ[]
	}
}

//==============================================================
//		ahm̓ǂݍ
//--------------------------------------------------------------
//	
//		string* 		_str		R[h
//		NSF_Header*		nsf_hed		NSFwb_[̓ǂݍݐ
//	Ԓl
//		size_t						ǂݍ.bint@CiNSFwb_[j
//==============================================================
std::streamsize	MusicFile::read_bin(string* _str, NSF_Header* nsf_hed)
{
	std::streamsize		bin_size	= 0;	//.bint@C̃TCY
	std::streamsize		code_size	= 0;	//AhCo[iR[hj̃TCY
	FileInput*			_romcode	= new FileInput();	

	//----------------------
	//t@CJ
	_romcode->fileopen(Header.romcode.c_str(), &(cOptionSW->m_pass_code));
	if(_romcode->isError() == true){
		f_error = true;	//_romcode new ςȂȂ̂ŁAł throw ȂB

	} else {

		char*	nsf_code	= new char[0xC000];			//.bint@Cǂݍ

		//----------------------
		//NSFpR[h̓]
		bin_size = _romcode->GetSize();
		code_size = bin_size - sizeof(NSF_Header);
		_romcode->read((char *)nsf_hed, sizeof(NSF_Header));
		_romcode->read(nsf_code, code_size);
		_romcode->close();

		//----------------------
		//NSFwb_[̍XV
		if(Header.title.size() < 32){
			Header.title.resize(32);
		}
		memcpy(&nsf_hed->Title, Header.title.c_str(), 32);

		if(Header.composer.size() < 32){
			Header.composer.resize(32);
		}
		memcpy(&nsf_hed->Composer, Header.composer.c_str(), 32);

		if(Header.copyright.size() < 32){
			Header.copyright.resize(32);
		}
		memcpy(&nsf_hed->Copyright, Header.copyright.c_str(), 32);

		nsf_hed->Version		= (unsigned char)(cOptionSW->iNSF_version);
		nsf_hed->MusicNumber	= (unsigned char)((Header.iBGM + Header.iSE) & 0xFF);
		if(Header.iExternal != -1){
			nsf_hed->External	= (unsigned char)Header.iExternal;
		}

		//----------------------
		//Exit
		_str->append(nsf_code, code_size);

		delete[]	nsf_code;

	}
	//----------------------
	//Exit
	delete		_romcode;

	return(code_size);

}

//==============================================================
//		V[PXf[^̍쐬
//--------------------------------------------------------------
//	
//		string* _str		R[h
//		size_t	code_size	*.biñTCYiNSFwb_[j
//		size_t	ptOffset	ROM̃ItZbgAhX
//								bankΉ̏ꍇ́A0x8000
//								bank@Ή̏ꍇ́A0x0000
//	Ԓl
//		size_t				V[PXf[^̃TCY
//	
//		NSFANSFep̋ȃf[^\B
//		Addr	Type	Contents
//		-------+-------+--------------------------
//		0000	BYTE	BGM f[^
//		0001	BYTE	SE  f[^
//		0002	WORD	nsd_dpcm\̂̃AhX
//		0004	WORD[]	BGM, SẼAhXA
//		xxxx	----	BGM, SẼV[PXf[^
//==============================================================
size_t	MusicFile::make_mus(string* _str, size_t code_size, size_t ptOffset)
{
	unsigned	int			i		= 2;
	unsigned	short*		pt;

				size_t		_size	= 4 + (Header.iBGM + Header.iSE)*2;
				size_t		size0	= _str->size();		//TCY

	//----------------------
	//oCiNAB
	code.clear();
	//̈̊m
	code.resize(_size);

	//ȃAhXiNSF, NSEepj̍쐬
	pt = (unsigned short*)code.c_str();

	code[0] = (char)(Header.iBGM & 0xFF);
	code[1] = (char)(Header.iSE  & 0xFF);

	if(Header.bank == false){

		if(cDPCMinfo != NULL){
			pt[1]	= (unsigned short)(ptOffset + code_size + _size + cDPCMinfo->getOffset());	//PCM info ̃AhX
		} else {
			pt[1]	= 0;
		}

		for(size_t n=0; n<Header.iBGM; n++){
			pt[i] = (unsigned short)(ptOffset + code_size + _size + ptcBGM[n]->getOffset());
			i++;
		}

		for(size_t n=0; n<Header.iSE; n++){
			pt[i] = (unsigned short)(ptOffset + code_size + _size + ptcSE[n]->getOffset());
			i++;
		}

	} else {

		if(cDPCMinfo != NULL){
			pt[1] = (unsigned short)(ptOffset + _size + cDPCMinfo->getOffset());	//PCM info ̃AhX
		} else {
			pt[1]	= 0;
		}

		for(size_t n=0; n<Header.iBGM; n++){
			pt[i] = (unsigned short)(ptOffset + _size + ptcBGM[n]->getOffset());
			i++;
		}

		for(size_t n=0; n<Header.iSE; n++){
			pt[i] = (unsigned short)(ptOffset + _size + ptcSE[n]->getOffset());
			i++;
		}

	}

	getCode(_str);

	return(_str->size() - size0);

}

//==============================================================
//		obl̍쐬
//--------------------------------------------------------------
//	
//		string* _str		R[h
//	Ԓl
//		size_t				PCMf[^̃TCY
//	
//
//==============================================================
size_t	MusicFile::make_dpcm(string* _str)
{
	//PCM̍쐬
	_str->append(dpcm_code);

	return(dpcm_code.size());
}

//==============================================================
//		mre̍쐬
//--------------------------------------------------------------
//	
//		NSF_Header*		NSF_Hed		wb_[
//		string*			NSF_Data	f[^
//	Ԓl
//		size_t						f[^̃TCY
//	
//
//--------------------------------------------------------------
size_t	MusicFile::make_bin(NSF_Header* NSF_Hed, string* NSF_Data)
{

	unsigned	int		i,j;

				size_t	iSizeLimit;		//TCY`FbNp

				size_t	code_size;
				size_t	mus_size;
				size_t	pcm_size;
				size_t	NSF_size;
	unsigned	char	code_bank = 3;	//oNΉ.biñoN
	unsigned	char	mus_bank;
	unsigned	char	pcm_bank;

				char	chk_Bank;		//NSFwb_[̃oN`FbNp

				bool	flag_Optimize	= cOptionSW->flag_Optimize;

	//----------------------
	//BINt@C̓ǂ݂
	code_size = read_bin(NSF_Data, NSF_Hed);
	if(isError() == true){
		//BINt@C̓ǂݍ݂ɎsĂI
			throw ios_base::failure(Header.romcode + ": " + strerror(errno));

	} else {

		//----------------------
		//BinAoNΉH
		//chk_Bank == 0	EEE@Ήbin
		//chk_Bank != 0	EEE@@Ήbin
		chk_Bank  = NSF_Hed->Bank[0];
		chk_Bank |= NSF_Hed->Bank[1];
		chk_Bank |= NSF_Hed->Bank[2];
		chk_Bank |= NSF_Hed->Bank[3];
		chk_Bank |= NSF_Hed->Bank[4];
		chk_Bank |= NSF_Hed->Bank[5];
		chk_Bank |= NSF_Hed->Bank[6];
		chk_Bank |= NSF_Hed->Bank[7];

		//----------------------
		//V[PX̍쐬
		if(chk_Bank == 0){

			//------------------------------
			//Bank Ήbin
			if(Header.bank == true){
				Err(_T("w.bint@ĆAPCM̃oNɑΉĂ܂B\nPCM̃oNɑΉ.bint@Cw肵ĂB"));
			}

			//TCY̏
			iSizeLimit = Header.offsetPCM - 0x8000;

			//V[PX̃oCi𐶐
			mus_size = make_mus(NSF_Data, code_size, 0x8000);
			mus_size += code_size;						//.bin  ȃIuWFNg𑫂Z

			//o
			_COUT << _T("[CODE & MUSIC]") << endl;
		} else {

			//------------------------------
			//BankΉbinH
			if(Header.bank == false){
				Err(_T("w.bint@ĆAPCM̃oNɑΉĂ܂B\n#BankR}hw肵ĂB"));
			}
			if(cOptionSW->iNSF_version >=2){
				NSF_Hed->Flags |= nsf_flag_IRQ_support;
			}

			//TCY̏
			iSizeLimit = 0x10000;

			//V[PX̃oCi𐶐
			mus_size = make_mus(NSF_Data, code_size, 0x0000);

			//o
			_COUT << _T("[CODE]") << endl;
			_COUT << _T("  Bank = 3") << endl;
			_COUT << _T("  Size = 12288 [Byte]") << endl;

			_COUT << _T("[MUSIC]") << endl;
		}

		//oŇvZ
		mus_bank = (unsigned char)(mus_size >> 12);
		if((mus_size & 0x0FFF) != 0){
			mus_bank++;
		}

		_COUT << _T("  Bank = ") << (unsigned int)mus_bank << endl;
		_COUT << _T("  Size = ") << (unsigned int)mus_size << _T(" [Byte] / ") << iSizeLimit << _T(" [Byte]") << endl;

		//TCY`FbN
		if(mus_size > iSizeLimit){
			Err(_T("R[hEV[PX̃TCYelz܂B"));
		}

		//----------------------
		//GAP̐
		if(cDPCMinfo != NULL){
			if(chk_Bank == 0){
				//0paddingB
				if(flag_Optimize == true){
					//V[PXf[^̃oN̈
					//PCM̃oN̊JnItZbg܂
					NSF_Data->resize(((size_t)mus_bank<<12) + (Header.offsetPCM & 0x0FFF));
				} else {
					//PCM̊Jnʒu܂
					NSF_Data->resize(Header.offsetPCM - 0x8000);
				}
			} else {
				//V[PXf[^̃oN̈
				//PCM̊Jnʒu܂
				NSF_Data->resize((((size_t)mus_bank + (size_t)code_bank)<<12) + (Header.offsetPCM - 0xC000));
			}
		}

		//----------------------
		//PCM
		_COUT << _T("[DPCM]") << endl;

		pcm_size = make_dpcm(NSF_Data);
		pcm_bank = (unsigned char)((pcm_size + (Header.offsetPCM & 0x0FFF)) >> 12);
		if((pcm_size & 0x0FFF) != 0){
			pcm_bank++;
		}

		//PCMTCY`FbN
		_COUT << _T("  Bank = ") << (size_t)pcm_bank << endl;
		_COUT << _T("  Size = ") << (size_t)pcm_size << _T(" [Byte]");
		if(chk_Bank == 0){
			_COUT << _T(" / ") << 0x10000 - Header.offsetPCM << _T(" [Byte]") << endl;

			if(	(Header.offsetPCM + pcm_size) > 0x10000	){
				Err(_T("PCM̃TCYelz܂B"));
			}
		} else {
			_COUT << endl;
			i = mus_bank + pcm_bank + code_bank;

			if(i > 255){
				Err(_T("oN̍v255z܂B"));
			}
		}

		//PCML && oN\̍œKL && bankΉ.bingꍇA
		//NSFwb_[ɁAoN
		if((chk_Bank == 0) && (cDPCMinfo != NULL) && (flag_Optimize == true)){
			i = 0;
			while(i < mus_bank){
				NSF_Hed->Bank[i] = (unsigned char)i;
				i++;
			}
			while(i < ((Header.offsetPCM - 0x8000)>>12)){
				NSF_Hed->Bank[i] = 0;
				i++;
			}
			j = 0;
			while(i < 8){
				if(j < pcm_bank){
					NSF_Hed->Bank[i] = mus_bank + (unsigned char)j;
				} else {
					NSF_Hed->Bank[i] = 0;
				}
				i++;
				j++;
			}
		}

		//----------------------
		//GAP̐
		if(chk_Bank == 0){
			NSF_size = NSF_Data->size();
			if((cDPCMinfo != NULL) && (flag_Optimize == true)){
				//oN0paddingB
				if((NSF_size & 0x0FFF) != 0){
					NSF_size = (NSF_size & 0xF000) + 0x1000;
					NSF_Data->resize(NSF_size);
				}
			}
		} else {
			//oN0paddingB
			NSF_size = ((size_t)mus_bank + (size_t)pcm_bank + (size_t)code_bank)<<12;
			//BANKΉ.bingꍇŁAA32kBytȅꍇA32kByteɂB
			if(NSF_size < 0x8000){
				NSF_size = 0x8000;
			}
			NSF_Data->resize(NSF_size);
		}

		//----------------------
		//NSF2̏ꍇATCYwb_[ɏ
		if(cOptionSW->iNSF_version >=2){
			NSF_Hed->szNSF_Data[0] = (char)( NSF_size      & 0xFF);
			NSF_Hed->szNSF_Data[1] = (char)((NSF_size>> 8) & 0xFF);
			NSF_Hed->szNSF_Data[2] = (char)((NSF_size>>16) & 0xFF);
		}
	}

	//----------------------
	//Exit
	return(NSF_size);

}

//==============================================================
//		mre`ւ̕ۑ
//--------------------------------------------------------------
//	
//		const	char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveNSF(string&	strFileName)
{
	NSF_Header*			NSF_Hed			= new NSF_Header;
				string	NSF_Data;
				size_t	NSF_size;

				string	Meta_data;
				size_t	Meta_size;

	try{

		_COUT << _T("----------------------------------------") << endl;
		_COUT << _T("*NSF build process") << endl;

		//==============================
		//----------------------
		//NA
		NSF_Data.clear();
		Meta_data.clear();

		//----------------------
		//NSF́Awb_[ƃf[^̍쐬
		NSF_size = make_bin(NSF_Hed, &NSF_Data);

		//==============================
		//Meta Data
		Meta_size = Header.getData(&Meta_data);

		//NENDł΁Ametadata̖ߍ݂͕sv
		if(Meta_size <= 8){
			Meta_size = 0;
		}

		//TCY\
		_COUT << _T("[Meta Data]") << endl;
		_COUT << _T("  Size = ") << (unsigned int)Meta_size << _T(" [Byte]") << endl;

		if(cOptionSW->iNSF_version >=2){
			//Meta Dataꍇ
			if(Meta_size > 0){
				NSF_Hed->Flags |= nsf_flag_MetaData;
			}
		}

		//==============================
		//NSF
		//----------------------
		//Open File
		fileopen(strFileName.c_str());
		if(isError() == true){
			throw ios_base::failure(strFileName + ": " + strerror(errno));
		} else {
			//----------------------
			//Write File
			write((char *)NSF_Hed, sizeof(NSF_Header));			//NSFwb_[̏
			write(NSF_Data.c_str(), NSF_size);					//f[^̏
			if((cOptionSW->iNSF_version>=2) && (Meta_size > 0)){
				write(Meta_data.c_str(), Meta_size);			//Meta datȁ
			}

			//----------------------
			//Close file
			close();
		}

	} catch (int no) {
		nsc_ErrMsg(no);
	} catch (const exception& e) {
		nsc_ErrMsg(e);
	}

	//==============================
	//Exit
	delete	NSF_Hed;
}

//==============================================================
//		mre`ւ̕ۑ
//--------------------------------------------------------------
//	
//		const	char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveNSFe(string&	strFileName)
{

	const		char	NSFE_Head[4]	= {0x4E, 0x53, 0x46, 0x45};		//NSFE

	NSF_Header*			NSF_Hed			= new NSF_Header;
				string	NSF_Data;

				string	Meta_data;
				size_t	Meta_size;

	try{

		_COUT << _T("----------------------------------------") << endl;
		_COUT << _T("*NSFe build process") << endl;

		//==============================
		//----------------------
		//NA
		NSF_Data.clear();
		Meta_data.clear();

		//----------------------
		//NSF́Awb_[ƃf[^̍쐬
		make_bin(NSF_Hed, &NSF_Data);		//oN\̍œK͂łĂB

		//==============================
		//^f[^̐
		//----------------------
		//DATA
		Header.Set_DATA(&NSF_Data);

		//----------------------
		//NSFepmetadeta(INFO, NSF2, BANK)
		Header.Set_NSFe_footer(NSF_Hed);

		//----------------------
		//oCiɕϊ
		Meta_size = Header.getData(&Meta_data);

		//TCY\
		_COUT << _T("[Meta Data]") << endl;
		_COUT << _T("  Size = ") << (unsigned int)Meta_size << _T(" [Byte]") << endl;

		//==============================
		//NSFE
		//----------------------
		//Open File
		fileopen(strFileName.c_str());
		if(isError() == true){
			throw ios_base::failure(strFileName + ": " + strerror(errno));
		} else {
			//----------------------
			//Write File
			write(NSFE_Head, sizeof(NSFE_Head));			//NSFwb_[̏
			write(Meta_data.c_str(), Meta_size);			//Meta datȁ

			//----------------------
			//Close file
			close();
		}

	} catch (int no) {
		nsc_ErrMsg(no);
	} catch (const exception& e) {
		nsc_ErrMsg(e);
	}

	//==============================
	//Exit
	delete	NSF_Hed;

}

//==============================================================
//		AZu\[Xւ̕ۑ
//--------------------------------------------------------------
//	
//		const	char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveASM(string&	strFileName)
{
	try{

		//----------------------
		//File open
		fileopen(strFileName.c_str());
		if(isError() == true){
			throw ios_base::failure(strFileName + ": " + strerror(errno));
		} else {

			//Header
			*this <<	";===============================================================\n"
						";		Music file for NES Sound Driver & Library\n"
						";			for assembly language (ca65.exe)\n"
						";===============================================================\n"
						<<endl;

			//Export of Sequence
			for(size_t n=0; n<Header.iBGM; n++){
				*this	<<	"	.export		"	<<	Header.Label	<<	"BGM"	<<	n	<<	endl;
			}

			for(size_t n=0; n<Header.iSE; n++){
				*this	<<	"	.export		"	<<	Header.Label	<<	"SE"	<<	n	<<	endl;
			}

			if(cDPCMinfo != NULL){
				*this	<<	"	.export		"	<<	Header.Label	<<	"DPCMinfo"	<<	endl;
			}

			//MML
			*this <<	"\n\n.segment	"	<<	'"'	<<	Header.segmentSEQ	<<	'"' << endl;

			getAsm(this);

			//----------------------
			//Close file
			close();
		}

	} catch (int no) {
		nsc_ErrMsg(no);
	} catch (const exception& e) {
		nsc_ErrMsg(e);
	}
}

//==============================================================
//		G[
//--------------------------------------------------------------
//	
//		const	_CHAR	msg[]	G[bZ[W
//	Ԓl
//				
//==============================================================
void	MusicFile::Err(const _CHAR msg[])
{
	_OMP_SET_LOCK(lock_cout)
	f_error = true;
	if(cOptionSW->fErr == true){
		_CERR << _T("[ ERROR ] : ") << msg << endl;
	} else {
		_COUT << _T("[ ERROR ] : ") << msg << endl;
	}
	_OMP_UNSET_LOCK(lock_cout)

	throw EXIT_FAILURE;		//{IɒvIȃG[Ȃ̂ŗO𓊂B
}

//--------------------------------------------------------------
void	MusicFile::Err(const _CHAR msg[], size_t no)
{
	_OMP_SET_LOCK(lock_cout)
	f_error = true;
	if(cOptionSW->fErr == true){
		_CERR << _T("[ ERROR ] : ") << msg << _T("(") << no << _T(")Ԃ݂܂B") << endl;
	} else {
		_COUT << _T("[ ERROR ] : ") << msg << _T("(") << no << _T(")Ԃ݂܂B") << endl;
	}
	_OMP_UNSET_LOCK(lock_cout)
}

//==============================================================
//		[jO
//--------------------------------------------------------------
//	
//		const	_CHAR	msg[]	[jObZ[W
//	Ԓl
//				
//==============================================================
void	MusicFile::Warning(const _CHAR msg[])
{
	_OMP_SET_LOCK(lock_cout)
	//݂̃t@CƁAs\
	if(cOptionSW->fErr == true){
		_CERR << _T("[WARNING] : ") << msg << endl;
	} else {
		_COUT << _T("[WARNING] : ") << msg << endl;
	}
	_OMP_UNSET_LOCK(lock_cout)
}
