/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "mml_general.h"

//==============================================================
//		RXgN^i0Bytej
//--------------------------------------------------------------
//	
//		unsigned	char	_code		R[h
//		const		char	_strName[]	NX̖O
//	Ԓl
//				
//==============================================================
mml_general::mml_general(unsigned char _code, const _CHAR _strName[]):
	MusicEvent(_strName)
{
	iSize = 1;
	code.resize(iSize);
	code[0] = _code;
}

//==============================================================
//		RXgN^i1Bytej
//--------------------------------------------------------------
//	
//		unsigned	char	_code		R[h
//		MMLfile*			MML			MMLt@C̃IuWFNg
//		const		char	_strName[]	NX̖O
//	Ԓl
//				
//==============================================================
mml_general::mml_general(unsigned char _code, MMLfile* MML, const _CHAR _strName[]):
	MusicEvent(_strName)
{
	int		_data = MML->GetInt();

	if( (_data<-128) || (_data>255) ){
		MML->Err(_T("p[^̒l͈͂z܂B"));
	}

	iSize = 2;
	code.resize(iSize);
	code[0] = (unsigned char)_code;
	code[1] = (unsigned char)_data;
}

//==============================================================
//			RXgN^i1Bytej
//--------------------------------------------------------------
//	
//		unsigned	char	_code		R[h
//		const		char	_data		
//		const		char	_strName[]	NX̖O
//	Ԓl
//				
//==============================================================
mml_general::mml_general(unsigned char _code, char _data, const _CHAR _strName[]):
	MusicEvent(_strName)
{
	iSize = 2;
	code.resize(iSize);
	code[0] = _code;
	code[1] = _data;
}

//==============================================================
//			RXgN^i2Bytej
//--------------------------------------------------------------
//	
//		unsigned	char	_code		R[h
//		const		char	_n1			1
//		const		char	_n2			2
//		const		char	_strName[]	NX̖O
//	Ԓl
//				
//==============================================================
mml_general::mml_general(unsigned char _code, char _n1, char _n2, const _CHAR _strName[]):
	MusicEvent(_strName)
{
	iSize = 3;
	code.resize(iSize);
	code[0] = _code;
	code[1] = _n1;
	code[2] = _n2;
}

//==============================================================
//			RXgN^i4Bytej
//--------------------------------------------------------------
//	
//		unsigned	char	_code		R[h
//		const		char	_n1			1
//		const		char	_n2			2
//		const		char	_n3			3
//		const		char	_n4			4
//		const		char	_strName[]	NX̖O
//	Ԓl
//				
//==============================================================
mml_general::mml_general(unsigned char _code, char _n1, char _n2, char _n3, char _n4, const _CHAR _strName[]):
	MusicEvent(_strName)
{
	iSize = 5;
	code.resize(iSize);
	code[0] = _code;
	code[1] = _n1;
	code[2] = _n2;
	code[3] = _n3;
	code[4] = _n4;
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
mml_general::~mml_general(void)
{
}
